/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.bodyinteger.implementation;

import fixtures.bodyinteger.AutoRestIntegerTestService;
import fixtures.bodyinteger.Ints;
import com.microsoft.rest.ServiceClient;
import okhttp3.OkHttpClient;
import retrofit2.Retrofit;

/**
 * Initializes a new instance of the AutoRestIntegerTestService class.
 */
public final class AutoRestIntegerTestServiceImpl extends ServiceClient implements AutoRestIntegerTestService {

    /**
     * The Ints object to access its operations.
     */
    private Ints ints;

    /**
     * Gets the Ints object to access its operations.
     * @return the Ints object.
     */
    public Ints ints() {
        return this.ints;
    }

    /**
     * Initializes an instance of AutoRestIntegerTestService client.
     */
    public AutoRestIntegerTestServiceImpl() {
        this("http://localhost");
    }

    /**
     * Initializes an instance of AutoRestIntegerTestService client.
     *
     * @param baseUrl the base URL of the host
     */
    public AutoRestIntegerTestServiceImpl(String baseUrl) {
        super(baseUrl);
        initialize();
    }

    /**
     * Initializes an instance of AutoRestIntegerTestService client.
     *
     * @param clientBuilder the builder for building an OkHttp client, bundled with user configurations
     * @param restBuilder the builder for building an Retrofit client, bundled with user configurations
     */
    public AutoRestIntegerTestServiceImpl(OkHttpClient.Builder clientBuilder, Retrofit.Builder restBuilder) {
        this("http://localhost", clientBuilder, restBuilder);
        initialize();
    }

    /**
     * Initializes an instance of AutoRestIntegerTestService client.
     *
     * @param baseUrl the base URL of the host
     * @param clientBuilder the builder for building an OkHttp client, bundled with user configurations
     * @param restBuilder the builder for building an Retrofit client, bundled with user configurations
     */
    public AutoRestIntegerTestServiceImpl(String baseUrl, OkHttpClient.Builder clientBuilder, Retrofit.Builder restBuilder) {
        super(baseUrl, clientBuilder, restBuilder);
        initialize();
    }

    private void initialize() {
        this.ints = new IntsImpl(retrofit(), this);
    }
}
